Index: /code/branches/network3/src/network/Client.cc
===================================================================
--- /code/branches/network3/src/network/Client.cc	(revision 1244)
+++ /code/branches/network3/src/network/Client.cc	(revision 1245)
@@ -84,4 +84,5 @@
     // set server address to localhost
     isConnected=false;
+    test_once=false;
   }
 
@@ -93,4 +94,5 @@
   Client::Client(std::string address, int port) : client_connection(port, address){
     isConnected=false;
+    test_once=false;
   }
 
@@ -102,4 +104,5 @@
   Client::Client(const char *address, int port) : client_connection(port, address){
     isConnected=false;
+    test_once=false;
   }
 
@@ -226,4 +229,17 @@
   */
   void Client::tick(float time){
+    if(client_connection.isConnected()){
+      COUT(4) << "popping partial gamestate: " << std::endl;
+      GameStateCompressed *gs = gamestate.popPartialGameState();
+      if(gs){
+        COUT(4) << "client tick: sending gs " << gs << std::endl;
+        if(client_connection.addPacket(pck_gen.gstate(gs)))
+          if(!client_connection.sendPackets())
+            COUT(3) << "Problem sending partial gamestate" << std::endl;
+        // now delete it to save memory
+        delete [] gs->data;
+        delete gs;
+      }
+    }
     ENetPacket *packet;
     // stop if the packet queue is empty
@@ -231,16 +247,21 @@
       packet = client_connection.getPacket();
       COUT(5) << "tick packet size " << packet->dataLength << std::endl;
-      elaborate(packet, 0); // ================= i guess we got to change this .... (client_ID is always same = server)
+      if(!test_once){
+        elaborate(packet, 0); // ================= i guess we got to change this .... (client_ID is always same = server)
+      }
     }
     return;
   }
 
-  void Client::processGamestate( GameStateCompressed *data){
-    int id = data->id;
-    COUT(5) << "received gamestate id: " << data->id << std::endl;
-    if(gamestate.pushGameState(data)){
-      client_connection.addPacket(pck_gen.acknowledgement(id));
-      if(!client_connection.sendPackets())
-        COUT(2) << "Could not send acknowledgment" << std::endl;
+  void Client::processGamestate( GameStateCompressed *data, int clientID){
+    if(!test_once){
+      int id = data->id;
+      COUT(5) << "received gamestate id: " << data->id << std::endl;
+      if(gamestate.pushGameState(data)){
+        client_connection.addPacket(pck_gen.acknowledgement(id));
+        if(!client_connection.sendPackets())
+          COUT(2) << "Could not send acknowledgment" << std::endl;
+      }
+//       test_once=true;
     }
   }
@@ -263,5 +284,5 @@
     clientID_ = w->clientID;
     shipID_ = w->shipID;
-    
+    return true;
   }
 
Index: /code/branches/network3/src/network/Client.h
===================================================================
--- /code/branches/network3/src/network/Client.h	(revision 1244)
+++ /code/branches/network3/src/network/Client.h	(revision 1245)
@@ -103,5 +103,5 @@
 
     // implement data processing functions of PacketDecoder
-    void processGamestate( GameStateCompressed *data);
+    void processGamestate( GameStateCompressed *data, int clientID);
     void processClassid(classid *clid);
     void processChat( chat *data);
@@ -109,4 +109,5 @@
     int clientID_;     // this is the id the server gave to us
     int shipID_;
+    bool test_once;
   };
 
Index: /code/branches/network3/src/network/ClientConnection.h
===================================================================
--- /code/branches/network3/src/network/ClientConnection.h	(revision 1244)
+++ /code/branches/network3/src/network/ClientConnection.h	(revision 1245)
@@ -76,4 +76,5 @@
     bool sendPackets(ENetEvent *event);
     bool waitEstablished(int milisec);
+    bool isConnected(){return established;}
   private:
     bool processData(ENetEvent *event);
Index: /code/branches/network3/src/network/ConnectionManager.cc
===================================================================
--- /code/branches/network3/src/network/ConnectionManager.cc	(revision 1244)
+++ /code/branches/network3/src/network/ConnectionManager.cc	(revision 1245)
@@ -165,5 +165,5 @@
     enet_initialize();
     atexit(enet_deinitialize);
-    ENetEvent event;
+    ENetEvent *event = new ENetEvent;
     server = enet_host_create(&bindAddress, NETWORK_MAX_CONNECTIONS, 0, 0);
     if(server==NULL){
@@ -174,13 +174,13 @@
 
     while(!quit){
-      if(enet_host_service(server, &event, NETWORK_WAIT_TIMEOUT)<0){
+      if(enet_host_service(server, event, NETWORK_WAIT_TIMEOUT)<0){
         // we should never reach this point
         quit=true;
         // add some error handling here ========================
       }
-      switch(event.type){
+      switch(event->type){
         // log handling ================
         case ENET_EVENT_TYPE_CONNECT:
-          addClient(&event);
+          addClient(event);
           //this is a workaround to ensure thread safety
           /*if(!addFakeConnectRequest(&event))
@@ -191,13 +191,14 @@
           //std::cout << "received data" << std::endl;
           COUT(5) << "Con.Man: receive event has occured" << std::endl;
-          processData(&event);
+          processData(event);
           break;
         case ENET_EVENT_TYPE_DISCONNECT:
-          // add some error/log handling here
-          clientDisconnect(event.peer);
+          clientDisconnect(event->peer);
           break;
         case ENET_EVENT_TYPE_NONE:
           break;
       }
+//       usleep(1000);
+      //yield(); //TODO: find apropriate
     }
     disconnectClients();
@@ -246,5 +247,5 @@
   bool ConnectionManager::clientDisconnect(ENetPeer *peer) {
     COUT(4) << "removing client from list" << std::endl;
-    return head_->removeClient(peer);
+    return removeClient(head_->findClient(&(peer->address))->getID());
   }
 /**
@@ -311,4 +312,19 @@
     sendWelcome(temp->getID(), temp->getShipID(), true);
     return true;
+  }
+  
+  bool ConnectionManager::removeClient(int clientID){
+    orxonox::Iterator<orxonox::SpaceShip> it = orxonox::ObjectList<orxonox::SpaceShip>::start();
+    while(it){
+      if(it->objectID!=head_->findClient(clientID)->getShipID()){
+        ++it;
+        continue;
+      }
+      orxonox::Iterator<orxonox::SpaceShip> temp=it;
+      ++it;
+      delete  *temp;
+      return head_->removeClient(clientID);
+    }
+    return false;
   }
   
@@ -335,5 +351,4 @@
     
     client->setShipID(no->objectID);
-    no->getFocus();
     return true;
   }
@@ -342,4 +357,5 @@
     addPacket(packet_gen.generateWelcome(clientID, shipID, allowed),clientID);
     sendPackets();
+    return true;
   }
   
Index: /code/branches/network3/src/network/ConnectionManager.h
===================================================================
--- /code/branches/network3/src/network/ConnectionManager.h	(revision 1244)
+++ /code/branches/network3/src/network/ConnectionManager.h	(revision 1245)
@@ -89,4 +89,5 @@
   private:
     bool clientDisconnect(ENetPeer *peer);
+    bool removeClient(int clientID);
     bool processData(ENetEvent *event);
     bool addClient(ENetEvent *event);
Index: /code/branches/network3/src/network/GameStateClient.cc
===================================================================
--- /code/branches/network3/src/network/GameStateClient.cc	(revision 1244)
+++ /code/branches/network3/src/network/GameStateClient.cc	(revision 1245)
@@ -166,4 +166,9 @@
 
   GameState *GameStateClient::getPartialSnapshot(){
+    
+    GameState *reference;
+//     std::map<int, GameState*>::iterator it = --gameStateMap.end();
+//     reference=(--gameStateMap.end())->second;
+    
     //std::cout << "begin getSnapshot" << std::endl;
     //the size of the gamestate
@@ -178,5 +183,7 @@
 
     GameState *retval=new GameState; //return value
-    retval->id=reference->id;
+//     retval->id=reference->id;
+    if(gameStateMap.size()!=0)
+      retval->id=(--gameStateMap.end())->second->id;
     retval->diffed=false;
     retval->complete=false;
@@ -190,4 +197,5 @@
       size+=it->getSize(); // size of the actual data of the synchronisable
       size+=3*sizeof(int); // size of datasize, classID and objectID
+      COUT(4) << "getpartialsnapshot: size: " << size << std::endl;
     }
     //retval->data = (unsigned char*)malloc(size);
Index: /code/branches/network3/src/network/GameStateClient.h
===================================================================
--- /code/branches/network3/src/network/GameStateClient.h	(revision 1244)
+++ /code/branches/network3/src/network/GameStateClient.h	(revision 1245)
@@ -70,5 +70,4 @@
     void printGameStateMap();
 
-    GameState     *reference;
     int           last_diff_;
     std::map<int, GameState *> gameStateMap;
Index: /code/branches/network3/src/network/GameStateManager.cc
===================================================================
--- /code/branches/network3/src/network/GameStateManager.cc	(revision 1244)
+++ /code/branches/network3/src/network/GameStateManager.cc	(revision 1245)
@@ -106,5 +106,8 @@
     if(gID != GAMESTATEID_INITIAL){
       // TODO something with the gamestatemap is wrong
-      GameState *client = gameStateMap.find(gID)->second;
+      GameState *client=NULL;
+      std::map<int, GameState*>::iterator it = gameStateMap.find(gID);
+      if(it!=gameStateMap.end())
+        client = it->second;
       GameState *server = reference;
       //head_->findClient(clientID)->setGamestateID(id);
@@ -203,4 +206,6 @@
 
   bool GameStateManager::loadPartialSnapshot(GameState *state, int clientID){
+    if(!state)
+      return false;
     unsigned char *data=state->data;
     COUT(4) << "loadSnapshot: loading gs: " << state->id << std::endl;
@@ -219,5 +224,5 @@
       sync.data = data;
       data+=sync.length;
-
+      COUT(4) << "objectID: " << sync.objectID << " classID: " << sync.classID << std::endl;
       while(it && it->objectID!=sync.objectID)
         ++it;
@@ -226,4 +231,5 @@
       if(!it){
         // the object does not exist yet
+        COUT(4) << "loadsnapshot: creating new object " << std::endl;
         //COUT(4) << "loadSnapshot:\tclassid: " << sync.classID << ", name: " << ID((unsigned int) sync.classID)->getName() << std::endl;
         orxonox::Identifier* id = ID((unsigned int)sync.classID);
@@ -244,4 +250,5 @@
       }else{
         // we have our object
+        COUT(4) << "loadpartialsnapshot: we found the appropriate object" << std::endl;
         if(checkAccess(clientID, sync.objectID)){
           if(! it->updateData(sync))
@@ -396,5 +403,5 @@
     //std::cout << "length " << length << std::endl;
     switch ( retval ) {
-      case Z_OK: COUT(4) << "successfully decompressed" << std::endl; break;
+      case Z_OK: COUT(5) << "successfully decompressed" << std::endl; break;
       case Z_MEM_ERROR: COUT(1) << "not enough memory available" << std::endl; return NULL;
       case Z_BUF_ERROR: COUT(2) << "not enough memory available in the buffer" << std::endl; return NULL;
@@ -444,5 +451,6 @@
   bool GameStateManager::checkAccess(int clientID, int objectID){
     // currently we only check, wheter the object is the clients spaceship
-    return head_->findClient(objectID)->getShipID()==objectID;
+//     return head_->findClient(objectID)->getShipID()==objectID;
+    return true; // TODO: change this
   }
 
Index: /code/branches/network3/src/network/PacketDecoder.cc
===================================================================
--- /code/branches/network3/src/network/PacketDecoder.cc	(revision 1244)
+++ /code/branches/network3/src/network/PacketDecoder.cc	(revision 1245)
@@ -78,5 +78,5 @@
       return true;
     case GAMESTATE:
-      gstate( packet );
+      gstate( packet, clientId );
       return true;
     case CLASSID:
@@ -155,5 +155,5 @@
   }
 
-  void PacketDecoder::gstate( ENetPacket* packet )
+  void PacketDecoder::gstate( ENetPacket* packet, int clientID )
   {
     GameStateCompressed* currentState = NULL;
@@ -190,5 +190,5 @@
     //clean memory
     enet_packet_destroy( packet );
-    processGamestate(currentState);
+    processGamestate(currentState, clientID);
   }
 
@@ -234,5 +234,5 @@
   }
 
-  void PacketDecoder::processGamestate( GameStateCompressed *state )
+  void PacketDecoder::processGamestate( GameStateCompressed *state, int clientID )
   {
     COUT(5) << "PacketDecoder: processing Gamestate" << std::endl;
Index: /code/branches/network3/src/network/PacketManager.h
===================================================================
--- /code/branches/network3/src/network/PacketManager.h	(revision 1244)
+++ /code/branches/network3/src/network/PacketManager.h	(revision 1245)
@@ -91,6 +91,6 @@
     void mousem( ENetPacket* packet, int clientId = CLIENTID_CLIENT );
     void keystrike( ENetPacket* packet, int clientId = CLIENTID_CLIENT );
-    void chatMessage( ENetPacket* packet, int clientId = CLIENTID_CLIENT);
-    void gstate( ENetPacket* packet );
+    void chatMessage( ENetPacket* packet, int clientId = CLIENTID_CLIENT );
+    void gstate( ENetPacket* packet, int clientID = CLIENTID_CLIENT );
     void clid( ENetPacket *packet);
     bool decodeWelcome( ENetPacket* packet, int clientID = CLIENTID_CLIENT );
@@ -99,5 +99,5 @@
     //process data
     //two functions are note yet implemented!
-    virtual void processGamestate(GameStateCompressed *state);
+    virtual void processGamestate(GameStateCompressed *state, int clientID);
     virtual void processAck( ack *data, int clientID);
     virtual void processClassid( classid *cid);
Index: /code/branches/network3/src/network/Server.cc
===================================================================
--- /code/branches/network3/src/network/Server.cc	(revision 1244)
+++ /code/branches/network3/src/network/Server.cc	(revision 1245)
@@ -143,5 +143,5 @@
     updateGamestate();
 
-    usleep(200000); // TODO remove
+//     usleep(500000); // TODO remove
     return;
   }
@@ -228,4 +228,13 @@
     //connection->addPacket(packet_gen.gstate(gamestates->popGameState(clientID)) , clientID);
     connection->createClient(clientID);
+    return true;
+  }
+  
+  void Server::processGamestate( GameStateCompressed *data, int clientID){
+    COUT(4) << "processing partial gamestate from client " << clientID << std::endl;
+    if(!gamestates->pushGameState(data, clientID))
+        COUT(3) << "Could not push gamestate\t\t\t\t=====" << std::endl;
+//     delete[] data->data;
+//     delete data;
   }
 
Index: /code/branches/network3/src/network/Server.h
===================================================================
--- /code/branches/network3/src/network/Server.h	(revision 1244)
+++ /code/branches/network3/src/network/Server.h	(revision 1245)
@@ -74,4 +74,5 @@
     void processAck( ack *data, int clientID);
     bool processConnectRequest( connectRequest *con, int clientID );
+    void processGamestate( GameStateCompressed *data, int clientID);
     ConnectionManager *connection;
     GameStateManager *gamestates;
Index: /code/branches/network3/src/network/Synchronisable.cc
===================================================================
--- /code/branches/network3/src/network/Synchronisable.cc	(revision 1244)
+++ /code/branches/network3/src/network/Synchronisable.cc	(revision 1245)
@@ -50,5 +50,5 @@
   
   
-  int Synchronisable::state_=1; // detemines wheter we are server (default) or client
+  int Synchronisable::state_=0x1; // detemines wheter we are server (default) or client
   
   /**
@@ -165,6 +165,8 @@
     for(i=syncList->begin(); n<datasize && i!=syncList->end(); ++i){
       //(std::memcpy(retVal.data+n, (const void*)(&(i->size)), sizeof(int));
-      if( ((*i)->mode & state_) == 0 )
+      if( ((*i)->mode & state_) == 0 ){
+        COUT(4) << "not getting data: " << std::endl;
         continue;  // this variable should only be received
+      }
       switch((*i)->type){
       case DATA:
@@ -199,6 +201,8 @@
     COUT(5) << "Synchronisable: objectID " << vars.objectID << ", classID " << vars.classID << " size: " << vars.length << " synchronising data" << std::endl;
     for(i=syncList->begin(); i!=syncList->end(); i++){
-      if( ((*i)->mode ^ state_) == 0 )
-        continue;  // this variable should only be sent
+      if( ((*i)->mode ^ state_) == 0 ){
+        COUT(5) << "synchronisable: not updating variable " << std::endl;
+        continue;  // this variable should only be updated
+      }
       COUT(5) << "Synchronisable: element size: " << (*i)->size << " type: " << (*i)->type << std::endl;
       switch((*i)->type){
Index: /code/branches/network3/src/orxonox/Orxonox.h
===================================================================
--- /code/branches/network3/src/orxonox/Orxonox.h	(revision 1244)
+++ /code/branches/network3/src/orxonox/Orxonox.h	(revision 1245)
Index: /code/branches/network3/src/orxonox/objects/SpaceShip.cc
===================================================================
--- /code/branches/network3/src/orxonox/objects/SpaceShip.cc	(revision 1244)
+++ /code/branches/network3/src/orxonox/objects/SpaceShip.cc	(revision 1245)
@@ -104,41 +104,4 @@
         this->setRotationAxis(1, 0, 0);
         this->setStatic(false);
-/*
-        this->moveForward_ = 0;
-        this->rotateUp_ = 0;
-        this->rotateDown_ = 0;
-        this->rotateRight_ = 0;
-        this->rotateLeft_ = 0;
-        this->loopRight_ = 0;
-        this->loopLeft_ = 0;
-        this->brakeForward_ = 0;
-        this->brakeRotate_ = 0;
-        this->brakeLoop_ = 0;
-        this->speedForward_ = 0;
-        this->speedRotateUpDown_ = 0;
-        this->speedRotateRightLeft_ = 0;
-        this->speedLoopRightLeft_ = 0;
-        this->maxSpeedForward_ = 0;
-        this->maxSpeedRotateUpDown_ = 0;
-        this->maxSpeedRotateRightLeft_ = 0;
-        this->maxSpeedLoopRightLeft_ = 0;
-        this->accelerationForward_ = 0;
-        this->accelerationRotateUpDown_ = 0;
-        this->accelerationRotateRightLeft_ = 0;
-        this->accelerationLoopRightLeft_ = 0;
-
-        this->speed = 250;
-        this->loop = 100;
-        this->rotate = 10;
-        this->mouseX = 0;
-        this->mouseY = 0;
-        this->maxMouseX = 0;
-        this->minMouseX = 0;
-        this->moved = false;
-
-        this->brakeRotate(rotate*10);
-        this->brakeLoop(loop);
-*/
-//         this->create();
 
 
@@ -161,10 +124,20 @@
 
     void SpaceShip::registerAllVariables(){
-      registerVar( &camName_, camName_.length()+1, network::STRING);
+      registerVar( &camName_, camName_.length()+1, network::STRING, 0x1);
+      registerVar( &maxSpeed_, sizeof(maxSpeed_), network::DATA, 0x1);
+      registerVar( &maxSideAndBackSpeed_, sizeof(maxSideAndBackSpeed_), network::DATA, 0x1);
+      registerVar( &maxRotation_, sizeof(maxRotation_), network::DATA, 0x1);
+      registerVar( &translationAcceleration_, sizeof(translationAcceleration_), network::DATA, 0x1);
+      registerVar( &rotationAcceleration_, sizeof(rotationAcceleration_), network::DATA, 0x1);
+      registerVar( &rotationAccelerationRadian_, sizeof(rotationAccelerationRadian_), network::DATA, 0x1);
+      registerVar( &translationDamping_, sizeof(translationDamping_), network::DATA, 0x1);
+      registerVar( &rotationDamping_, sizeof(rotationDamping_), network::DATA, 0x1);
+      registerVar( &rotationDampingRadian_, sizeof(rotationDampingRadian_), network::DATA, 0x1);
+      
     }
 
     void SpaceShip::init()
     {
-        COUT(4) << "================ \t\t\t\tspaceship::init" << std::endl;
+//         COUT(4) << "================ \t\t\t\tspaceship::init" << std::endl;
         // START CREATING THRUSTER
         this->tt_ = new ParticleInterface(GraphicsEngine::getSingleton().getSceneManager(),"twinthruster" + this->getName(),"Orxonox/engineglow");
@@ -197,9 +170,9 @@
         this->greenNode_->setInheritScale(false);
 
-        COUT(4) << "attaching red billboard" << std::endl;
+//         COUT(4) << "attaching red billboard" << std::endl;
         this->redNode_->attachObject(this->redBillboard_.getBillboardSet());
         this->redNode_->setScale(0.3, 0.3, 0.3);
 
-        COUT(4) << "attaching green billboard" << std::endl;
+//         COUT(4) << "attaching green billboard" << std::endl;
         this->greenNode_->attachObject(this->greenBillboard_.getBillboardSet());
         this->greenNode_->setScale(0.3, 0.3, 0.3);
@@ -215,12 +188,12 @@
         this->chFarNode_->setInheritScale(false);
 
-        COUT(4) << "attaching crosshair near billboard" << std::endl;
+//         COUT(4) << "attaching crosshair near billboard" << std::endl;
         this->chNearNode_->attachObject(this->crosshairNear_.getBillboardSet());
         this->chNearNode_->setScale(0.2, 0.2, 0.2);
 
-        COUT(4) << "attaching crosshair far billboard" << std::endl;
+//         COUT(4) << "attaching crosshair far billboard" << std::endl;
         this->chFarNode_->attachObject(this->crosshairFar_.getBillboardSet());
         this->chFarNode_->setScale(0.4, 0.4, 0.4);
-        COUT(4) << "attaching camera" << std::endl;
+//         COUT(4) << "attaching camera" << std::endl;
         
         createCamera();
@@ -237,5 +210,5 @@
     void SpaceShip::loadParams(TiXmlElement* xmlElem)
     {
-      COUT(4) << "using loadparams" << std::endl;
+//       COUT(4) << "using loadparams" << std::endl;
         Model::loadParams(xmlElem);
         this->create();
@@ -303,5 +276,5 @@
     
     void SpaceShip::createCamera(){
-      COUT(4) << "begin camera creation" << std::endl;
+//       COUT(4) << "begin camera creation" << std::endl;
       this->camNode_ = this->getNode()->createChildSceneNode(camName_);
       COUT(4) << "position: (this)" << this->getNode()->getPosition() << std::endl;
@@ -313,16 +286,18 @@
       cam->lookAt(Vector3(0,20,0));
       cam->roll(Degree(0));
-      */COUT(4) << "creating new camera" << std::endl;
+      *//*COUT(4) << "creating new camera" << std::endl;*/
       cam_ = new Camera(this->camNode_);
-      COUT(4) << "setting target node" << std::endl;
+//       COUT(4) << "setting target node" << std::endl;
       cam_->setTargetNode(this->getNode());
       // this only applies to clients
-      if(network::Client::getSingleton()!=0 && network::Client::getSingleton()->getShipID()==objectID)
+      if(network::Client::getSingleton()!=0 && network::Client::getSingleton()->getShipID()==objectID){
+        this->setBacksync(true);
         CameraHandler::getInstance()->requestFocus(cam_);
+      }
 //        cam->setPosition(Vector3(0,-350,0));
       //cam->roll(Degree(-90));
 
       //this->camNode_->attachObject(cam);
-      COUT(4) << "created camera" << std::endl;
+//       COUT(4) << "created camera" << std::endl;
     }
 
@@ -460,5 +435,5 @@
     {
         // only do this if not client TODO: remove this hack
-      if (!network::Client::getSingleton() && InputManager::getSingleton().getMouse()->getEventCallback() != this)
+      if ((!network::Client::getSingleton() || network::Client::getSingleton()->getShipID()==objectID ) && InputManager::getSingleton().getMouse()->getEventCallback() != this)
         {
             if (InputManager::getSingleton().getMouse())
@@ -485,5 +460,6 @@
         if (this->bLMousePressed_ && this->timeToReload_ <= 0)
         {
-            new Projectile(this);
+            Projectile *p = new Projectile(this);
+            p->setBacksync(true);
             this->timeToReload_ = this->reloadTime_;
         }
@@ -560,4 +536,5 @@
 
         if(!network::Client::getSingleton() || network::Client::getSingleton()->getShipID() == objectID){
+          COUT(4) << "steering our ship: " << objectID << " mkeyboard: " << mKeyboard << std::endl;
           if (mKeyboard->isKeyDown(OIS::KC_UP) || mKeyboard->isKeyDown(OIS::KC_W))
               this->acceleration_.x = this->translationAcceleration_;
@@ -580,5 +557,6 @@
           else
               this->momentum_ = 0;
-        }
+        }/*else
+          COUT(4) << "not steering ship: " << objectID << " our ship: " << network::Client::getSingleton()->getShipID() << std::endl;*/
 
         WorldEntity::tick(dt);
Index: /code/branches/network3/src/orxonox/objects/WorldEntity.cc
===================================================================
--- /code/branches/network3/src/orxonox/objects/WorldEntity.cc	(revision 1244)
+++ /code/branches/network3/src/orxonox/objects/WorldEntity.cc	(revision 1245)
@@ -81,4 +81,5 @@
         if (!this->bStatic_)
         {
+//             COUT(4) << "acceleration: " << this->acceleration_ << " velocity: " << this->velocity_ << std::endl;
             this->velocity_ += (dt * this->acceleration_);
             this->translate(dt * this->velocity_, Ogre::Node::TS_LOCAL);
@@ -222,7 +223,7 @@
       //register acceleration
       // register velocity_
-      registerVar( (void*) &(this->getAcceleration().x), sizeof(this->getAcceleration().x), network::DATA, 0x3);
-      registerVar( (void*) &(this->getAcceleration().y), sizeof(this->getAcceleration().y), network::DATA, 0x3);
-      registerVar( (void*) &(this->getAcceleration().z), sizeof(this->getAcceleration().z), network::DATA, 0x3);
+//       registerVar( (void*) &(this->getAcceleration().x), sizeof(this->getAcceleration().x), network::DATA, 0x3);
+//       registerVar( (void*) &(this->getAcceleration().y), sizeof(this->getAcceleration().y), network::DATA, 0x3);
+//       registerVar( (void*) &(this->getAcceleration().z), sizeof(this->getAcceleration().z), network::DATA, 0x3);
     }
 