Index: /code/branches/network3/src/network/Client.cc
===================================================================
--- /code/branches/network3/src/network/Client.cc	(revision 1245)
+++ /code/branches/network3/src/network/Client.cc	(revision 1246)
@@ -235,6 +235,5 @@
         COUT(4) << "client tick: sending gs " << gs << std::endl;
         if(client_connection.addPacket(pck_gen.gstate(gs)))
-          if(!client_connection.sendPackets())
-            COUT(3) << "Problem sending partial gamestate" << std::endl;
+          COUT(3) << "Problem adding partial gamestate to queue" << std::endl;
         // now delete it to save memory
         delete [] gs->data;
@@ -251,4 +250,6 @@
       }
     }
+    if(!client_connection.sendPackets())
+      COUT(3) << "Problem sending packets to server" << std::endl;
     return;
   }
@@ -260,6 +261,7 @@
       if(gamestate.pushGameState(data)){
         client_connection.addPacket(pck_gen.acknowledgement(id));
-        if(!client_connection.sendPackets())
-          COUT(2) << "Could not send acknowledgment" << std::endl;
+        // we do this at the end of a tick
+//        if(!client_connection.sendPackets())
+//          COUT(2) << "Could not send acknowledgment" << std::endl;
       }
 //       test_once=true;
Index: /code/branches/network3/src/network/ConnectionManager.cc
===================================================================
--- /code/branches/network3/src/network/ConnectionManager.cc	(revision 1245)
+++ /code/branches/network3/src/network/ConnectionManager.cc	(revision 1246)
@@ -199,5 +199,5 @@
           break;
       }
-//       usleep(1000);
+      usleep(100);
       //yield(); //TODO: find apropriate
     }
Index: /code/branches/network3/src/network/GameStateClient.cc
===================================================================
--- /code/branches/network3/src/network/GameStateClient.cc	(revision 1245)
+++ /code/branches/network3/src/network/GameStateClient.cc	(revision 1246)
@@ -289,10 +289,10 @@
 
     switch ( retval ) {
-      case Z_OK: COUT(5) << "G.St.Man: compress: successfully compressed" << std::endl; break;
-      case Z_MEM_ERROR: COUT(1) << "G.St.Man: compress: not enough memory available in gamestate.compress" << std::endl; 
-      return NULL;
-      case Z_BUF_ERROR: COUT(2) << "G.St.Man: compress: not enough memory available in the buffer in gamestate.compress" << std::endl;
-      return NULL;
-      case Z_DATA_ERROR: COUT(2) << "G.St.Man: compress: data corrupted in gamestate.compress" << std::endl;
+      case Z_OK: COUT(5) << "G.St.Cl: compress: successfully compressed" << std::endl; break;
+      case Z_MEM_ERROR: COUT(1) << "G.St.Cl: compress: not enough memory available in gamestate.compress" << std::endl; 
+      return NULL;
+      case Z_BUF_ERROR: COUT(2) << "G.St.Cl: compress: not enough memory available in the buffer in gamestate.compress" << std::endl;
+      return NULL;
+      case Z_DATA_ERROR: COUT(2) << "G.St.Cl: compress: data corrupted in gamestate.compress" << std::endl;
       return NULL;
     }
Index: /code/branches/network3/src/network/GameStateManager.cc
===================================================================
--- /code/branches/network3/src/network/GameStateManager.cc	(revision 1245)
+++ /code/branches/network3/src/network/GameStateManager.cc	(revision 1246)
@@ -260,5 +260,7 @@
       ++it;
     }
-
+    
+    delete[] state->data;
+    delete state;
     return true;
   }
Index: /code/branches/network3/src/network/Server.cc
===================================================================
--- /code/branches/network3/src/network/Server.cc	(revision 1245)
+++ /code/branches/network3/src/network/Server.cc	(revision 1246)
@@ -210,4 +210,7 @@
       added=true;
       temp=temp->next();
+      // now delete gamestate
+      delete[] gs->data;
+      delete gs;
     }
     if(added) {
@@ -222,4 +225,5 @@
     COUT(4) << "Server: processing ack from client: " << clientID << "; ack-id: " << data->a << std::endl;
     gamestates->ackGameState(clientID, data->a);
+    delete data;
   }
   
@@ -235,6 +239,4 @@
     if(!gamestates->pushGameState(data, clientID))
         COUT(3) << "Could not push gamestate\t\t\t\t=====" << std::endl;
-//     delete[] data->data;
-//     delete data;
   }
 