Index: code/branches/ogre/src/core/Debug.h
===================================================================
--- code/branches/ogre/src/core/Debug.h	(revision 1248)
+++ code/branches/ogre/src/core/Debug.h	(revision 1249)
@@ -273,5 +273,5 @@
 #define CCOUT_EXEC(x) \
   orxonox::OutputHandler::getOutStream().setOutputLevel(x) \
-  << "*** " << this->getIdentifier()->getName() << ": "
+  << this->getIdentifier()->getName() << ": "
 
 #ifndef CCOUT
Index: code/branches/ogre/src/orxonox/GraphicsEngine.cc
===================================================================
--- code/branches/ogre/src/orxonox/GraphicsEngine.cc	(revision 1248)
+++ code/branches/ogre/src/orxonox/GraphicsEngine.cc	(revision 1249)
@@ -52,5 +52,5 @@
     @return The only instance of GraphicsEngine.
   */
-  GraphicsEngine& GraphicsEngine::getSingleton()
+  /*static*/ GraphicsEngine& GraphicsEngine::getSingleton()
   {
     static GraphicsEngine theOnlyInstance;
@@ -61,14 +61,25 @@
     @brief Only use constructor to initialise variables and pointers!
   */
-  GraphicsEngine::GraphicsEngine()
+  GraphicsEngine::GraphicsEngine() :
+    root_(0),
+    scene_(0),
+    renderWindow_(0),
+    //configPath_(""),
+    dataPath_(""),
+    ogreLogfile_("")
   {
     RegisterObject(GraphicsEngine);
-    // set to standard values
-    this->configPath_ = "";
-    this->root_ = 0;
-    this->scene_ = 0;
-    this->renderWindow_ = 0;
+
     this->setConfigValues();
     CCOUT(4) << "Constructed" << std::endl;
+  }
+
+  void GraphicsEngine::setConfigValues()
+  {
+    SetConfigValue(dataPath_, "../../Media/").description("relative path to media data");
+    SetConfigValue(ogreLogfile_, "ogre.log").description("Logfile for messages from Ogre. Use \"\" to suppress log file creation.");
+    SetConfigValue(ogreLogLevelTrivial_ , 5).description("Corresponding orxonox debug level for ogre Trivial");
+    SetConfigValue(ogreLogLevelNormal_  , 4).description("Corresponding orxonox debug level for ogre Normal");
+    SetConfigValue(ogreLogLevelCritical_, 2).description("Corresponding orxonox debug level for ogre Critical");
   }
 
@@ -102,13 +113,4 @@
     }
     COUT(4) << "Destroying objects done" << std::endl;
-  }
-
-  void GraphicsEngine::setConfigValues()
-  {
-    SetConfigValue(dataPath_, "../../Media/").description("relative path to media data");
-    SetConfigValue(ogreLogfile_, "ogre.log").description("Logfile for messages from Ogre. Use \"\" to suppress log file creation.");
-    SetConfigValue(ogreLogLevelTrivial_ , 5).description("Corresponding orxonox debug level for ogre Trivial");
-    SetConfigValue(ogreLogLevelNormal_  , 4).description("Corresponding orxonox debug level for ogre Normal");
-    SetConfigValue(ogreLogLevelCritical_, 2).description("Corresponding orxonox debug level for ogre Critical");
   }
 
Index: code/branches/ogre/src/orxonox/GraphicsEngine.h
===================================================================
--- code/branches/ogre/src/orxonox/GraphicsEngine.h	(revision 1248)
+++ code/branches/ogre/src/orxonox/GraphicsEngine.h	(revision 1249)
@@ -94,5 +94,5 @@
             Ogre::RenderWindow* renderWindow_;//!< the current render window
             //bool               bOverwritePath_; //!< overwrites path
-            std::string         configPath_;  //!< path to config file
+            //std::string         configPath_;  //!< path to config file
             std::string         dataPath_;    //!< path to data file
             std::string         ogreLogfile_; //!< log file name for Ogre log messages
Index: code/branches/ogre/src/orxonox/Main.cc
===================================================================
--- code/branches/ogre/src/orxonox/Main.cc	(revision 1248)
+++ code/branches/ogre/src/orxonox/Main.cc	(revision 1249)
@@ -78,11 +78,13 @@
     Orxonox* orx = Orxonox::getSingleton();
 
+    bool res = false;
 #if ORXONOX_PLATFORM == ORXONOX_PLATFORM_APPLE
-    orx->init(argc, argv, macBundlePath());
+    res = orx->init(argc, argv, macBundlePath());
 #else
-    orx->init(argc, argv, "");
+    res = orx->init(argc, argv, "");
 #endif
 
-    orx->start();
+    if (res)
+      orx->start();
     orx->destroySingleton();
   /*}
Index: code/branches/ogre/src/orxonox/Orxonox.cc
===================================================================
--- code/branches/ogre/src/orxonox/Orxonox.cc	(revision 1248)
+++ code/branches/ogre/src/orxonox/Orxonox.cc	(revision 1249)
@@ -158,17 +158,17 @@
    * Create a new instance of Orxonox. Avoid doing any actual work here.
    */
-  Orxonox::Orxonox()
-  {
-    this->mode_ = STANDALONE;
-    this->serverIp_ = "";
-    this->ogre_ = &GraphicsEngine::getSingleton();
-    this->timer_ = 0;
-    //this->auMan_ = 0;
-    this->orxonoxHUD_ = 0;
-    this->inputHandler_ = 0;
+  Orxonox::Orxonox() :
+    ogre_(&GraphicsEngine::getSingleton()),
+    //auMan_(0),
+    timer_(0),
     // turn on frame smoothing by setting a value different from 0
-    this->frameSmoothingTime_ = 0.0f;
-    this->bAbort_ = false;
-    this->timefactor_ = 1.0f;
+    frameSmoothingTime_(0.0f),
+    orxonoxConsole_(0),
+    orxonoxHUD_(0),
+    bAbort_(false),
+    timefactor_(1.0f),
+    mode_(STANDALONE),
+    serverIp_("")
+  {
   }
 
Index: code/branches/ogre/src/orxonox/Orxonox.h
===================================================================
--- code/branches/ogre/src/orxonox/Orxonox.h	(revision 1248)
+++ code/branches/ogre/src/orxonox/Orxonox.h	(revision 1249)
@@ -94,5 +94,4 @@
       GraphicsEngine*       ogre_;          //!< our dearest graphics engine <3
       //audio::AudioManager*  auMan_;         //!< audio manager
-      InputManager*         inputHandler_;  //!< Handles input with key bindings
       Ogre::Timer*          timer_;         //!< Main loop timer
       // TODO: make this a config-value by creating a config class for orxonox
Index: code/branches/ogre/src/orxonox/console/InGameConsole.cc
===================================================================
--- code/branches/ogre/src/orxonox/console/InGameConsole.cc	(revision 1248)
+++ code/branches/ogre/src/orxonox/console/InGameConsole.cc	(revision 1249)
@@ -54,9 +54,18 @@
     const float BLINK = 0.25;
 
-    InGameConsole::InGameConsole(InputBuffer* ib){
+    InGameConsole::InGameConsole(InputBuffer* ib) :
+        windowW(0), windowH(0),
+        scroll(0), scrollTimer(0.0f),
+        cursor(0.0f),
+        active(false),
+        ib_(ib),
+        om(0),
+        consoleOverlay(0),
+        consoleOverlayContainer(0),
+        consoleOverlayNoise(0),
+        consoleOverlayBorder(0),
+        consoleOverlayTextAreas(0)
+    {
         //RegisterObject(InGameConsole);
-        ib_ = ib;
-        active = false;
-        cursor = 0.0;
         init();
     }